Attribute VB_Name = "Module_Rotation"
Option Explicit

Private Declare Function SetDIBits Lib "gdi32" (ByVal hdc As Long, ByVal hBitmap As Long, ByVal nStartScan As Long, ByVal nNumScans As Long, lpBits As Any, lpBI As BITMAPINFO, ByVal wUsage As Long) As Long
Private Declare Function GetDIBits Lib "gdi32" (ByVal aHDC As Long, ByVal hBitmap As Long, ByVal nStartScan As Long, ByVal nNumScans As Long, lpBits As Any, lpBI As BITMAPINFO, ByVal wUsage As Long) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function CreateCompatibleBitmap Lib "gdi32" (ByVal hdc As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long

Private Type BITMAPINFOHEADER
   biSize As Long
   biWidth As Long
   biHeight As Long
   biPlanes As Integer
   biBitCount As Integer
   biCompression As Long
   biSizeImage As Long
   biXPelsPerMeter As Long
   biYPelsPerMeter As Long
   biClrUsed As Long
   biClrImportant As Long
End Type
Private Type RGBQUAD
   rgbBlue As Byte
   rgbGreen As Byte
   rgbRed As Byte
   rgbReserved As Byte
End Type

Private Type BITMAPINFO
   bmiHeader As BITMAPINFOHEADER
   bmiColors As RGBQUAD
End Type

Private ReadBuffer() As RGBQUAD
Private WriteBuffer() As RGBQUAD

Private Function GethBmp(hdc As Long) As Long
   Dim OldBmp As Long
   OldBmp = SelectObject(hdc, CreateCompatibleBitmap(hdc, 1, 1))
   GethBmp = OldBmp
   OldBmp = SelectObject(hdc, OldBmp)
   DeleteObject OldBmp
End Function

Private Sub PicToBuffer(PichDC As Long, Width As Long, Height As Long)
   Dim BMPINFO As BITMAPINFO
   Dim BMPINFOH As BITMAPINFOHEADER

   ReDim ReadBuffer(Width, Height)
   With BMPINFOH
      .biBitCount = 32
      .biHeight = Height + 1
      .biWidth = Width + 1
      .biPlanes = 1
      .biSize = Len(BMPINFOH)
   End With
   BMPINFO.bmiHeader = BMPINFOH
   
   GetDIBits PichDC, GethBmp(PichDC), 0, Height + 1, ReadBuffer(0, 0), BMPINFO, 0
   WriteBuffer = ReadBuffer
End Sub

Private Sub BufferToPic(PichDC As Long)
   Dim BMPINFO As BITMAPINFO
   Dim BMPINFOH As BITMAPINFOHEADER
   
   Dim Width  As Long: Width = UBound(WriteBuffer, 1) + 1
   Dim Height As Long: Height = UBound(WriteBuffer, 2) + 1
   
   With BMPINFOH
      .biBitCount = 32
      .biHeight = Height
      .biWidth = Width
      .biPlanes = 1
      .biSize = Len(BMPINFOH)
   End With
   BMPINFO.bmiHeader = BMPINFOH
   
   SetDIBits PichDC, GethBmp(PichDC), 0, Height, WriteBuffer(0, 0), BMPINFO, 0
End Sub

Public Sub Init(hDcFrom As Long, Width As Long, Height As Long)
   PicToBuffer hDcFrom, Width, Height
End Sub

Public Sub Rotate(Angle As Integer, hDcTarget As Long)
   If Angle = 0 Then
      WriteBuffer = ReadBuffer
   Else
      Dim Width As Long: Width = UBound(ReadBuffer, 1)
      Dim Height As Long: Height = UBound(ReadBuffer, 2)
      
      Select Case Angle
         Case 90:  ReDim WriteBuffer(Height, Width)
         Case 180:  ReDim WriteBuffer(Width, Height)
         Case 270:  ReDim WriteBuffer(Height, Width)
      End Select
      
      Dim x As Long, y As Long
      For x = 0 To Width
         For y = 0 To Height
            Select Case Angle
               Case 90
                  WriteBuffer(y, Width - x) = ReadBuffer(x, y)
               Case 180
                  WriteBuffer(Width - x, Height - y) = ReadBuffer(x, y)
               Case 270
                  WriteBuffer(Height - y, x) = ReadBuffer(x, y)
            End Select
         Next y
      Next x
   End If
   
   BufferToPic hDcTarget
End Sub
