VERSION 5.00
Begin VB.UserControl ReyOrientLabel 
   AutoRedraw      =   -1  'True
   ClientHeight    =   270
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   2115
   BeginProperty Font 
      Name            =   "Arial"
      Size            =   9.75
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ScaleHeight     =   18
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   141
End
Attribute VB_Name = "ReyOrientLabel"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Declare Function TextOut Lib "gdi32" Alias "TextOutA" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal lpString As String, ByVal nCount As Long) As Long

Public Enum AngleConstants
   [Angle : Droite] = 0
   [Angle : Bas] = 90
   [Angle : Gauche] = 180
   [Angle : Haut] = 270
End Enum

Public Enum BackStyleConstants
   [BackStyle : Opaque] = 0
   [BackStyle : Transparent] = 1
End Enum

Private mAngle As AngleConstants
Private mBackStyle As BackStyleConstants
Private mAutoSize As Boolean
Private mCaption As String

Public Event Change()
Public Event Click()
Public Event DblClick()
Public Event MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
Public Event MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
Public Event MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)

Private lMustRedraw As Boolean

Public Property Get Caption() As String: Caption = mCaption: End Property
Attribute Caption.VB_ProcData.VB_Invoke_Property = ";Texte"
Attribute Caption.VB_UserMemId = 0
Attribute Caption.VB_MemberFlags = "200"
Public Property Let Caption(new_Caption As String)
   mCaption = new_Caption
   Refresh
   RaiseEvent Change
End Property

Public Property Get BackColor() As OLE_COLOR: BackColor = UserControl.BackColor: End Property
Public Property Let BackColor(new_BackColor As OLE_COLOR)
   UserControl.BackColor = new_BackColor
   Refresh
End Property

Public Property Get FontSize() As Single: FontSize = UserControl.FontSize: End Property
Attribute FontSize.VB_MemberFlags = "400"
Public Property Let FontSize(new_FontSize As Single)
   UserControl.FontSize = new_FontSize
   Refresh
End Property

Public Property Get FontBold() As Boolean: FontBold = UserControl.FontBold: End Property
Attribute FontBold.VB_MemberFlags = "400"
Public Property Let FontBold(new_FontBold As Boolean)
   UserControl.FontBold = new_FontBold
   Refresh
End Property

Public Property Get FontItalic() As Boolean: FontItalic = UserControl.FontItalic: End Property
Attribute FontItalic.VB_MemberFlags = "400"
Public Property Let FontItalic(new_FontItalic As Boolean)
   UserControl.FontItalic = new_FontItalic
   Refresh
End Property

Public Property Get FontUnderline() As Boolean: FontUnderline = UserControl.FontUnderline: End Property
Attribute FontUnderline.VB_MemberFlags = "400"
Public Property Let FontUnderline(new_FontUnderline As Boolean)
   UserControl.FontUnderline = new_FontUnderline
   Refresh
End Property

Public Property Get FontStrikeThru() As Boolean: FontStrikeThru = UserControl.FontStrikeThru: End Property
Attribute FontStrikeThru.VB_MemberFlags = "400"
Public Property Let FontStrikeThru(new_FontStrikeThru As Boolean)
   UserControl.FontStrikeThru = new_FontStrikeThru
   Refresh
End Property

Public Property Get FontName() As String: FontName = UserControl.FontName: End Property
Attribute FontName.VB_MemberFlags = "400"
Public Property Let FontName(new_FontName As String)
   UserControl.FontName = new_FontName
   Refresh
End Property

Public Property Get ForeColor() As OLE_COLOR: ForeColor = UserControl.ForeColor: End Property
Public Property Let ForeColor(new_ForeColor As OLE_COLOR)
   UserControl.ForeColor = new_ForeColor
   Refresh
End Property

Public Property Get AutoSize() As Boolean: AutoSize = mAutoSize: End Property
Public Property Let AutoSize(new_AutoSize As Boolean)
   mAutoSize = new_AutoSize
   Refresh
End Property

Public Property Get Angle() As AngleConstants: Angle = mAngle: End Property
Public Property Let Angle(new_Angle As AngleConstants)
   mAngle = new_Angle
   Refresh
End Property

Public Property Get BackStyle() As BackStyleConstants: BackStyle = mBackStyle: End Property
Public Property Let BackStyle(new_BackStyle As BackStyleConstants)
   mBackStyle = new_BackStyle
   Refresh
End Property

Public Sub Refresh()
   Call UserControl_Paint
End Sub

Public Property Get Font() As StdFont: Set Font = UserControl.Font: End Property
Public Property Set Font(new_Font As StdFont)
   Set UserControl.Font = new_Font
   Refresh
End Property

Private Sub UserControl_Click()
   RaiseEvent Click
End Sub

Private Sub UserControl_DblClick()
   RaiseEvent DblClick
End Sub

Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
   RaiseEvent MouseDown(Button, Shift, x, y)
End Sub

Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
   RaiseEvent MouseMove(Button, Shift, x, y)
End Sub

Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
   RaiseEvent MouseUp(Button, Shift, x, y)
End Sub

Private Sub UserControl_Paint()
   lMustRedraw = False
   Cls
   If Not mAutoSize Then
      Dim lWidth As Long: lWidth = Width
      Dim lHeight As Long: lHeight = Height
   End If
   
   Width = ScaleX(TextWidth(mCaption), vbPixels, vbTwips)
   Height = ScaleY(TextHeight(mCaption), vbPixels, vbTwips)
   
   TextOut UserControl.hdc, 0, 0, mCaption, Len(mCaption)
   Module_Rotation.Init UserControl.hdc, ScaleWidth - 1, ScaleHeight - 1
      
   UserControl.Cls
   
   If mAutoSize Then
      If (mAngle = [Angle : Bas] Or mAngle = [Angle : Haut]) Then
         Height = ScaleY(TextWidth(mCaption), vbPixels, vbTwips)
         Width = ScaleX(TextHeight(mCaption), vbPixels, vbTwips)
      End If
   Else
      Width = lWidth
      Height = lHeight
   End If
   
   Module_Rotation.Rotate CInt(mAngle), UserControl.hdc
      
   If mBackStyle = [BackStyle : Opaque] Then
      UserControl.BackStyle = 1
   Else
      UserControl.BackStyle = vbTransparent
      UserControl.MaskColor = BackColor
      Set UserControl.MaskPicture = UserControl.Image
   End If
   UserControl.Refresh
   lMustRedraw = True
End Sub

Private Sub UserControl_InitProperties()
   Me.Caption = Ambient.DisplayName
   Me.BackColor = Ambient.BackColor
   Me.ForeColor = Ambient.ForeColor
   Me.AutoSize = False
   Set Me.Font = Ambient.Font
   Me.BackStyle = [BackStyle : Opaque]
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
   With PropBag
      Me.Caption = .ReadProperty("Caption", Ambient.DisplayName)
      Me.Angle = .ReadProperty("Angle", 270)
      Me.BackColor = .ReadProperty("BackColor", Ambient.BackColor)
      Me.ForeColor = .ReadProperty("ForeColor", Ambient.ForeColor)
      Me.AutoSize = .ReadProperty("AutoSize", False)
      Me.BackStyle = .ReadProperty("BackStyle", [BackStyle : Opaque])
      Set Me.Font = .ReadProperty("Font", Ambient.Font)
   End With
End Sub

Private Sub UserControl_Resize()
   If lMustRedraw Then Refresh
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
   With PropBag
      .WriteProperty "Caption", Me.Caption, Ambient.DisplayName
      .WriteProperty "Angle", Me.Angle, 0
      .WriteProperty "AutoSize", Me.AutoSize, False
      .WriteProperty "BackColor", Me.BackColor, Ambient.BackColor
      .WriteProperty "ForeColor", Me.ForeColor, Ambient.ForeColor
      .WriteProperty "Font", Me.Font, Ambient.Font
      .WriteProperty "BackStyle", Me.BackStyle, [BackStyle : Opaque]
   End With
End Sub
